// Mem bug examples
// many memory leaks
//
// Klaus Kusche, 2014

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define ELEMS 30
#define ITERS 100
#define MAXSIZE 1000

int main(void)
{
  char *a[ELEMS];
  int i;

  srand(time(NULL));
  
  for (i = 0; i < ELEMS; ++i) {
    a[i] = NULL;
  }

  for (i = 0; i < ITERS; ++i) {
    int n = rand() % ELEMS;
    if (a[n] == NULL) {
      a[n] = (char *) (malloc(rand() % MAXSIZE));
    } else {
      free(a[n]);
      a[n] = NULL;
    }
  }

  for (i = 0; i < ITERS; ++i) {
    int n = rand() % ELEMS;
    if (a[n] == NULL) {
      a[n] = (char *) (malloc(rand() % MAXSIZE));
    } else {
      free(a[n]);
      a[n] = NULL;
    }
  }

  for (i = 0; i < ITERS; ++i) {
    int n = rand() % ELEMS;
    if (a[n] == NULL) {
      a[n] = (char *) (malloc(rand() % MAXSIZE));
    } else {
      free(a[n]);
      a[n] = NULL;
    }
  }
  
  return 0;
}
